OpenTTD Source: NWidgetViewport Class Reference

OpenTTD Source 14.0-beta3

Public Member Functions
NWidgetViewport Class Reference
Hierarchical widgets

Nested widget to display a viewport in a window. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetViewport:

## Public Member Functions
| NWidgetViewport (WidgetID index)
void | SetupSmallestSize (Window *w) override
void | Draw (const Window *w) override
void | InitializeViewport (Window *w, std::variant< TileIndex, VehicleID > focus, ZoomLevel zoom)
| Initialize the viewport of the window. More...
void | UpdateViewportCoordinates (Window *w)
| Update the position and size of the viewport (after eg a resize). More...
Public Member Functions inherited from NWidgetCore
| NWidgetCore (WidgetType tp, Colours colour, WidgetID index, uint fill_x, uint fill_y, uint32_t widget_data, StringID tool_tip)
| Initialization of a 'real' widget. More...
void | SetDataTip (uint32_t widget_data, StringID tool_tip)
| Set data and tool tip of the nested widget. More...
void | SetToolTip (StringID tool_tip)
| Set the tool tip of the nested widget. More...
void | SetTextStyle (TextColour colour, FontSize size)
| Set the text style of the nested widget. More...
void | SetAlignment (StringAlignment align)
| Set the text/image alignment of the nested widget. More...
void | SetLowered (bool lowered)
| Lower or raise the widget. More...
bool | IsLowered () const
| Return whether the widget is lowered.
void | SetDisabled (bool disabled)
| Disable (grey-out) or enable the widget. More...
bool | IsDisabled () const
| Return whether the widget is disabled.
void | FillWidgetLookup (WidgetLookup &widget_lookup) override
NWidgetCore * | GetWidgetFromPos (int x, int y) override
bool | IsHighlighted () const override
| Return whether the widget is highlighted.
TextColour | GetHighlightColour () const override
| Return the colour of the highlight.
void | SetHighlighted (TextColour highlight_colour) override
| Highlight the widget or not. More...
Public Member Functions inherited from NWidgetResizeBase
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets. More...
void | AdjustPaddingForZoom () override
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget. More...
void | SetMinimalSizeAbsolute (uint min_x, uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
void | SetMinimalTextLines (uint8_t min_lines, uint8_t spacing, FontSize size)
| Set minimal text lines for the widget. More...
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size. More...
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget. More...
bool | UpdateMultilineWidgetSize (const std::string &str, int max_lines)
| Try to set optimum widget size for a multiline text widget. More...
bool | UpdateSize (uint min_x, uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
bool | UpdateVerticalSize (uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
void | AssignSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height, bool rtl) override
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type. More...
template<class NWID >
NWID * | GetParentWidget ()
| Get parent widget of type NWID. More...
template<class NWID >
const NWID * | GetParentWidget () const
| Get parent widget of type NWID. More...
virtual void | SetHighlighted ([[maybe_unused]] TextColour highlight_colour)
void | SetPadding (uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
| Set additional space (padding) around the widget. More...
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Additional Inherited Members
Data Fields inherited from NWidgetCore
NWidgetDisplay | disp_flags
| Flags that affect display and interaction with the widget.
Colours | colour
| Colour of this widget.
const WidgetID | index
| Index of the nested widget (`-1` means 'not used').
uint32_t | widget_data
| Data of the widget. More...
StringID | tool_tip
| Tooltip of the widget. More...
WidgetID | scrollbar_index
| Index of an attached scrollbar.
TextColour | highlight_colour
| Colour of highlight.
TextColour | text_colour
| Colour of text within widget.
FontSize | text_size
| Size of text within widget.
StringAlignment | align
| Alignment of text/image within widget.
Data Fields inherited from NWidgetResizeBase
uint | min_x
| Minimal horizontal size of only this widget.
uint | min_y
| Minimal vertical size of only this widget.
bool | absolute
| Set if minimum size is fixed and should not be resized.
uint | uz_min_x
| Unscaled Minimal horizontal size of only this widget.
uint | uz_min_y
| Unscaled Minimal vertical size of only this widget.
uint8_t | uz_text_lines
| 'Unscaled' text lines, stored for resize calculation.
uint8_t | uz_text_spacing
| 'Unscaled' text padding, stored for resize calculation.
FontSize | uz_text_size
| 'Unscaled' font size, stored for resize calculation.
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
RectPadding | padding
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding
| Unscaled padding, for resize calculation.
NWidgetBase * | parent
| Parent widget of this widget, automatically filled in when added to container.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height)
| Store size and position. More...

## Detailed Description

Nested widget to display a viewport in a window.

After initializing the nested widget tree, call InitializeViewport(). After changing the window size, call UpdateViewportCoordinates() eg from Window::OnResize(). If the disp_flags field contains the ND_NO_TRANSPARENCY bit, the viewport will disable transparency. Shading to grey-scale is controlled with the ND_SHADE_GREY bit (used for B&W news papers), the ND_SHADE_DIMMED gives dimmed colours (for colour news papers).

Todo:
  Class derives from NWidgetCore, but does not use colour, widget_data, or tool_tip.

Definition at line 664 of file widget_type.h.

## Member Function Documentation

## ◆ Draw()

void NWidgetViewport::Draw | ( | const Window * | w | ) |
| overridevirtual

Draw the widgets of the tree. The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 2201 of file widget.cpp.

References _transparency_opt, NWidgetBase::current_x, NWidgetBase::current_y, NWidgetCore::disp_flags, Window::DrawViewport(), FILLRECT_RECOLOUR, GfxFillRect(), ND_NO_TRANSPARENCY, ND_SHADE_DIMMED, ND_SHADE_GREY, PALETTE_NEWSPAPER, PALETTE_TO_TRANSPARENT, TO_SIGNS, and TO_TEXT.

## ◆ InitializeViewport()

void NWidgetViewport::InitializeViewport | ( | Window * | w,
|  | std::variant< TileIndex, VehicleID > | focus,
|  | ZoomLevel | zoom
| ) |  |

Initialize the viewport of the window.

Parameters

  w | Window owning the viewport.
  focus | Either the tile index or vehicle ID to focus.
  zoom | Zoom level.

Definition at line 2228 of file widget.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, InitializeWindowViewport(), NWidgetBase::pos_x, and NWidgetBase::pos_y.

Referenced by WaypointWindow::WaypointWindow().

## ◆ SetupSmallestSize()

void NWidgetViewport::SetupSmallestSize | ( | Window * | w | ) |
| overridevirtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 2195 of file widget.cpp.

References NWidgetResizeBase::min_x, NWidgetResizeBase::min_y, NWidgetBase::smallest_x, and NWidgetBase::smallest_y.

## ◆ UpdateViewportCoordinates()

void NWidgetViewport::UpdateViewportCoordinates | ( | Window * | w | ) |

Update the position and size of the viewport (after eg a resize).

Parameters

  w | Window owning the viewport.

Definition at line 2237 of file widget.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, Viewport::height, Viewport::left, Window::left, NWidgetBase::pos_x, NWidgetBase::pos_y, ScaleByZoom(), Viewport::top, Window::top, Window::viewport, Viewport::virtual_height, Viewport::virtual_width, Viewport::width, and Viewport::zoom.

Referenced by ExtraViewportWindow::OnResize(), WaypointWindow::OnResize(), MainWindow::OnResize(), NewsWindow::OnResize(), TownViewWindow::OnResize(), IndustryViewWindow::OnResize(), and VehicleViewWindow::OnResize().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp